* ****  viewclip.prg  ********
DECLARE INTEGER CountClipboardFormats IN WIN32API
DECLARE INTEGER OpenClipboard IN WIN32API INTEGER
DECLARE INTEGER CloseClipboard IN WIN32API
DECLARE INTEGER EnumClipboardFormats IN WIN32API INTEGER
DECLARE INTEGER GetClipboardFormatName IN WIN32API INTEGER, STRING@, INTEGER

DECLARE INTEGER GetClipboardData IN WIN32API INTEGER
DECLARE INTEGER GlobalSize IN WIN32API INTEGER
DECLARE INTEGER GlobalLock IN WIN32API INTEGER
DECLARE INTEGER GlobalUnlock IN WIN32API INTEGER

* Predefined Clipboard Formats
#DEFINE CF_TEXT             1
#DEFINE CF_BITMAP           2
#DEFINE CF_METAFILEPICT     3
#DEFINE CF_SYLK             4
#DEFINE CF_DIF              5
#DEFINE CF_TIFF             6
#DEFINE CF_OEMTEXT          7
#DEFINE CF_DIB              8
#DEFINE CF_PALETTE          9
#DEFINE CF_PENDATA          10
#DEFINE CF_RIFF             11
#DEFINE CF_WAVE             12
#DEFINE CF_UNICODETEXT      13
#DEFINE CF_ENHMETAFILE      14
#DEFINE CF_HDROP            15
#DEFINE CF_LOCALE           16
#DEFINE CF_MAX              17

DECLARE laFormats[17]
laFormats[1]  = 'CF_TEXT'
laFormats[2]  = 'CF_BITMAP'
laFormats[3]  = 'CF_METAFILEPICT'
laFormats[4]  = 'CF_SYLK'
laFormats[5]  = 'CF_DIF'
laFormats[6]  = 'CF_TIFF'
laFormats[7]  = 'CF_OEMTEXT'
laFormats[8]  = 'CF_DIB'
laFormats[9]  = 'CF_PALETTE'
laFormats[10] = 'CF_PENDATA'
laFormats[11] = 'CF_RIFF'
laFormats[12] = 'CF_WAVE'
laFormats[13] = 'CF_UNICODETEXT'
laFormats[14] = 'CF_ENHMETAFILE'
laFormats[15] = 'CF_HDROP (Win 95)'
laFormats[16] = 'CF_LOCALE (Win 95)'
laFormats[17] = 'CF_MAX (Win 95)'

lnNumFormats = CountClipboardFormats()

CLEAR
? lnNumFormats, 'Clipboard Formats'
?

OpenClipboard(0)

lnFormat = 0
FOR N = 1 TO lnNumFormats
  lnFormat     = EnumClipboardFormats(lnFormat)
  lcFormatName = REPLICATE(CHR(0), 40)
  lnLen        = GetClipboardFormatName(lnFormat, @lcFormatName, 40)
  DO CASE
  CASE lnLen > 0
    ? lnFormat, STRTRAN(lcFormatName, CHR(0), '')
  CASE BETWEEN(lnFormat, 1, ALEN(laFormats, 1))
    ? lnFormat, laFormats[lnFormat]
  CASE lnFormat = 0x80
    ? lnFormat, 'CF_OWNERDISPLAY'
  CASE lnFormat = 0x81
    ? lnFormat, 'CF_DSPTEXT'
  CASE lnFormat = 0x82
    ? lnFormat, 'CF_DSPBITMAP'
  CASE lnFormat = 0x83
    ? lnFormat, 'CF_DSPMETAFILEPICT'
  CASE lnFormat = 0x8E
    ? lnFormat, 'CF_DSPENHMETAFILE'
  CASE BETWEEN(lnFormat, 0x0200, 0x02FF)
    ? lnFormat, 'sten formt'
  CASE BETWEEN(lnFormat, 0x0300, 0x03FF)
    ? lnFormat, 'Objekt GDI' 
  OTHERWISE
    ? lnFormat, "Neznm formt..."
  ENDCASE
    
ENDFOR

lcFormat = INPUTBOX('Zadejte formt kter si chcete prohldnout', 'Clipboard Format', '', 0, '', '')
lnFormat = INT(VAL(lcFormat))

lnClipHandle = GetClipboardData(lnFormat)
IF lnClipHandle <> 0
  lnPointer = GlobalLock(lnClipHandle)
  lnSize    = GlobalSize(lnClipHandle)

  IF lnSize > 0
    lcClipData = SYS(2600, lnPointer, lnSize)
  ENDIF

  GlobalUnlock(lnClipHandle)

  IF .NOT. EMPTY(lcClipData)
    SET SAFETY OFF
    STRTOFILE(lcClipData, 'CLIPTEXT.TXT', .F.)
    SET SAFETY ON
    DO (HOME() + 'tools\hexedit\hexedit.app') WITH 'cliptext.txt'
  ENDIF
ENDIF
CloseClipboard()
